// CD 04/2006
// tst affichage MUX -
// CE PROGRAMME EST UN EXEMPLE DE GESTION D'UN AFFICHEUR MULTIPLEXE 7 SEGMENTS
// Le programme doit tre complt par la gestion du port SPI et la rcupration de spo2 et pouls
// gestion de 4 afficheurs anodes communume, allumage par 0
// le cadencement est assur par le timer0 en IT toutes les 8,192mS (quartz 4Mhz)
// le nombre N est affich et incrment toutes les 0,5s 

#include <p18f452.h>

#define DATA PORTB		// donnee 7 seg
#define DDRDATA	DDRB

#define KAFF1 PORTCbits.RC3		// cathode aff 1
#define KAFF2 PORTCbits.RC2
#define KAFF3 PORTCbits.RC1
#define KAFF4 PORTCbits.RC0

#define DDRKAFF1 DDRCbits.RC3
#define DDRKAFF2 DDRCbits.RC2
#define DDRKAFF3 DDRCbits.RC1
#define DDRKAFF4 DDRCbits.RC0

// prototypes
void traiteIT(void); 		// prototype car le vecteur est dclar avant la sp d'IT
void mux(void);
void decode (unsigned int D);

// donnees decimales des 4 afficheurs 7 seg
unsigned char DAFF1;		// centaines
unsigned char DAFF2;		// dizaines
unsigned char DAFF3;		// unites
unsigned char DAFF4;		// divers

// codes 7 seg (a definir) !!!!!!!!! 
rom unsigned char code7seg[]={0,11,22,33,44,55,66,77,88,99};

unsigned int N; // nombre a afficher

#pragma code it=0x08		// le vecteur d'IT prioritaire envoie  l'adresse 8
void saut_sur_spIT(void)	// une fonction, car en C tout est dans une fonction
{
_asm
	goto traiteIT			
_endasm
}
#pragma code				// le compilateur peut  nouveau grer les adresses


#pragma interrupt traiteIT	// traiteIT est un SP d'IT 
void traiteIT(void)			
{static unsigned int tictac=0;
	if(INTCONbits.TMR0IF)			//vrifie un dbordement sur TMR0 
			{						
			INTCONbits.TMR0IF = 0;	//efface le drapeau d'IT
			mux();					// multiplexage
			if (++tictac>61)		// s'est il passe 0.5S ?
					{
						if (++N >999) N=0;		// incrmente compteur pour test environ toutes les secondes
						decode(N);	// decode le noueau N
						tictac=0;
					}
			}
}


// multiplexage de l'affichage
void mux(void)
{
	if (!KAFF1)				// si l'afficheur 1 est allume
		{
			KAFF1=1;		// l'eteindre
			DATA=code7seg[DAFF2];	// placer le code d'allumage
			KAFF2=0;		// allumer le suivant
		}
	else if (!KAFF2)	
		{
			KAFF2=1;
			DATA=code7seg[DAFF3];
			KAFF3=0;
		}
	else if (!KAFF3)	
		{
			KAFF3=1;
			DATA=code7seg[DAFF4];
			KAFF4=0;
		}
	else if (!KAFF4)	
		{
			KAFF4=1;
			DATA=code7seg[DAFF1];
			KAFF1=0;
		}
Nop();
}

// decodage 
void decode (unsigned int D)
{
// recherche les chiffres des centaines, dizaines et unites de D
	DAFF1=D/100;
	DAFF2=(D-(unsigned int)DAFF1*100)/10;
	DAFF3=D-(unsigned int)DAFF1*100-(unsigned int)DAFF2*10;
}


// programme de test
void main (void)
{
	DATA=0xFF;
	DDRDATA=0;
	DDRKAFF1=0;
	DDRKAFF2=0;
	DDRKAFF3=0;
	DDRKAFF4=0;
	
	KAFF1=1;
	KAFF2=1;
	KAFF3=1;
	KAFF4=0;	// afficheur allume pour commencer

	DAFF4=8;		// allumme tout sur l'afficheur 4

	N=0;		// compteur de secondes 
	decode(N);

	T0CON = 0b11001100;				//Active le TIMER0 MODE 8bits - prescaler 1:32 (IT toutes les 1uS*256*32=8192uS
	INTCONbits.TMR0IE = 1;			//Autorise interruption sur TMR0 
	INTCONbits.GIEH = 1;		

	while(1);
}
